import { Plugin as $, PluginKey as N, Selection as O, TextSelection as b, NodeSelection as ae } from "@tiptap/pm/state";
import { DecorationSet as xe, Decoration as Se } from "@tiptap/pm/view";
import "@tiptap/pm/keymap";
import { Fragment as L, Slice as be, DOMParser as Me } from "@tiptap/pm/model";
import { liftTarget as Ae, joinPoint as ce, canSplit as R, ReplaceStep as Te, ReplaceAroundStep as Ce, canJoin as le } from "@tiptap/pm/transform";
import { createParagraphNear as Ee, deleteSelection as Be, exitCode as ve, joinUp as Ie, joinDown as Pe, joinBackward as $e, joinForward as Ne, joinTextblockBackward as Oe, joinTextblockForward as je, lift as Fe, liftEmptyBlock as Le, newlineInCode as Re, selectNodeBackward as De, selectNodeForward as ze, selectParentNode as We, selectTextblockEnd as He, selectTextblockStart as Ke, setBlockType as ee, wrapIn as Ve } from "@tiptap/pm/commands";
import { liftListItem as _e, sinkListItem as Je, wrapInList as Ue } from "@tiptap/pm/schema-list";
import { bundledThemes as de, bundledLanguages as ue, createHighlighter as Ge } from "shiki";
function fe(e) {
  const { state: t, transaction: n } = e;
  let { selection: o } = n, { doc: r } = n, { storedMarks: s } = n;
  return {
    ...t,
    apply: t.apply.bind(t),
    applyTransaction: t.applyTransaction.bind(t),
    plugins: t.plugins,
    schema: t.schema,
    reconfigure: t.reconfigure.bind(t),
    toJSON: t.toJSON.bind(t),
    get storedMarks() {
      return s;
    },
    get selection() {
      return o;
    },
    get doc() {
      return r;
    },
    get tr() {
      return o = n.selection, r = n.doc, s = n.storedMarks, n;
    }
  };
}
class qe {
  constructor(t) {
    this.editor = t.editor, this.rawCommands = this.editor.extensionManager.commands, this.customState = t.state;
  }
  get hasCustomState() {
    return !!this.customState;
  }
  get state() {
    return this.customState || this.editor.state;
  }
  get commands() {
    const { rawCommands: t, editor: n, state: o } = this, { view: r } = n, { tr: s } = o, a = this.buildProps(s);
    return Object.fromEntries(Object.entries(t).map(([i, c]) => [i, (...u) => {
      const d = c(...u)(a);
      return !s.getMeta("preventDispatch") && !this.hasCustomState && r.dispatch(s), d;
    }]));
  }
  get chain() {
    return () => this.createChain();
  }
  get can() {
    return () => this.createCan();
  }
  createChain(t, n = !0) {
    const { rawCommands: o, editor: r, state: s } = this, { view: a } = r, i = [], c = !!t, l = t || s.tr, u = () => (!c && n && !l.getMeta("preventDispatch") && !this.hasCustomState && a.dispatch(l), i.every((f) => f === !0)), d = {
      ...Object.fromEntries(Object.entries(o).map(([f, p]) => [f, (...h) => {
        const g = this.buildProps(l, n), k = p(...h)(g);
        return i.push(k), d;
      }])),
      run: u
    };
    return d;
  }
  createCan(t) {
    const { rawCommands: n, state: o } = this, r = !1, s = t || o.tr, a = this.buildProps(s, r);
    return {
      ...Object.fromEntries(Object.entries(n).map(([c, l]) => [c, (...u) => l(...u)({ ...a, dispatch: void 0 })])),
      chain: () => this.createChain(s, r)
    };
  }
  buildProps(t, n = !0) {
    const { rawCommands: o, editor: r, state: s } = this, { view: a } = r, i = {
      tr: t,
      editor: r,
      view: a,
      state: fe({
        state: s,
        transaction: t
      }),
      dispatch: n ? () => {
      } : void 0,
      chain: () => this.createChain(t, n),
      can: () => this.createCan(t),
      get commands() {
        return Object.fromEntries(Object.entries(o).map(([c, l]) => [c, (...u) => l(...u)(i)]));
      }
    };
    return i;
  }
}
function w(e, t, n) {
  return e.config[t] === void 0 && e.parent ? w(e.parent, t, n) : typeof e.config[t] == "function" ? e.config[t].bind({
    ...n,
    parent: e.parent ? w(e.parent, t, n) : null
  }) : e.config[t];
}
function Qe(e) {
  const t = e.filter((r) => r.type === "extension"), n = e.filter((r) => r.type === "node"), o = e.filter((r) => r.type === "mark");
  return {
    baseExtensions: t,
    nodeExtensions: n,
    markExtensions: o
  };
}
function y(e, t) {
  if (typeof e == "string") {
    if (!t.nodes[e])
      throw Error(`There is no node type named '${e}'. Maybe you forgot to add the extension?`);
    return t.nodes[e];
  }
  return e;
}
function Xe(...e) {
  return e.filter((t) => !!t).reduce((t, n) => {
    const o = { ...t };
    return Object.entries(n).forEach(([r, s]) => {
      if (!o[r]) {
        o[r] = s;
        return;
      }
      if (r === "class") {
        const i = s ? s.split(" ") : [], c = o[r] ? o[r].split(" ") : [], l = i.filter((u) => !c.includes(u));
        o[r] = [...c, ...l].join(" ");
      } else
        r === "style" ? o[r] = [o[r], s].join("; ") : o[r] = s;
    }), o;
  }, {});
}
function Ye(e) {
  return typeof e == "function";
}
function x(e, t = void 0, ...n) {
  return Ye(e) ? t ? e.bind(t)(...n) : e(...n) : e;
}
function Ze(e) {
  return Object.prototype.toString.call(e) === "[object RegExp]";
}
class et {
  constructor(t) {
    this.find = t.find, this.handler = t.handler;
  }
}
function tt(e) {
  return Object.prototype.toString.call(e).slice(8, -1);
}
function V(e) {
  return tt(e) !== "Object" ? !1 : e.constructor === Object && Object.getPrototypeOf(e) === Object.prototype;
}
function Q(e, t) {
  const n = { ...e };
  return V(e) && V(t) && Object.keys(t).forEach((o) => {
    V(t[o]) ? o in e ? n[o] = Q(e[o], t[o]) : Object.assign(n, { [o]: t[o] }) : Object.assign(n, { [o]: t[o] });
  }), n;
}
class C {
  constructor(t = {}) {
    this.type = "extension", this.name = "extension", this.parent = null, this.child = null, this.config = {
      name: this.name,
      defaultOptions: {}
    }, this.config = {
      ...this.config,
      ...t
    }, this.name = this.config.name, t.defaultOptions && Object.keys(t.defaultOptions).length > 0 && console.warn(`[tiptap warn]: BREAKING CHANGE: "defaultOptions" is deprecated. Please use "addOptions" instead. Found in extension: "${this.name}".`), this.options = this.config.defaultOptions, this.config.addOptions && (this.options = x(w(this, "addOptions", {
      name: this.name
    }))), this.storage = x(w(this, "addStorage", {
      name: this.name,
      options: this.options
    })) || {};
  }
  static create(t = {}) {
    return new C(t);
  }
  configure(t = {}) {
    const n = this.extend();
    return n.options = Q(this.options, t), n.storage = x(w(n, "addStorage", {
      name: n.name,
      options: n.options
    })), n;
  }
  extend(t = {}) {
    const n = new C({ ...this.config, ...t });
    return n.parent = this, this.child = n, n.name = t.name ? t.name : n.parent.name, t.defaultOptions && console.warn(`[tiptap warn]: BREAKING CHANGE: "defaultOptions" is deprecated. Please use "addOptions" instead. Found in extension: "${n.name}".`), n.options = x(w(n, "addOptions", {
      name: n.name
    })), n.storage = x(w(n, "addStorage", {
      name: n.name,
      options: n.options
    })), n;
  }
}
function nt(e, t, n) {
  const { from: o, to: r } = t, { blockSeparator: s = `

`, textSerializers: a = {} } = n || {};
  let i = "", c = !0;
  return e.nodesBetween(o, r, (l, u, d, f) => {
    var p;
    const m = a == null ? void 0 : a[l.type.name];
    if (m)
      return l.isBlock && !c && (i += s, c = !0), d && (i += m({
        node: l,
        pos: u,
        parent: d,
        index: f,
        range: t
      })), !1;
    l.isText ? (i += (p = l == null ? void 0 : l.text) === null || p === void 0 ? void 0 : p.slice(Math.max(o, u) - u, r - u), c = !1) : l.isBlock && !c && (i += s, c = !0);
  }), i;
}
function ot(e) {
  return Object.fromEntries(Object.entries(e.nodes).filter(([, t]) => t.spec.toText).map(([t, n]) => [t, n.spec.toText]));
}
C.create({
  name: "clipboardTextSerializer",
  addOptions() {
    return {
      blockSeparator: void 0
    };
  },
  addProseMirrorPlugins() {
    return [
      new $({
        key: new N("clipboardTextSerializer"),
        props: {
          clipboardTextSerializer: () => {
            const { editor: e } = this, { state: t, schema: n } = e, { doc: o, selection: r } = t, { ranges: s } = r, a = Math.min(...s.map((u) => u.$from.pos)), i = Math.max(...s.map((u) => u.$to.pos)), c = ot(n);
            return nt(o, { from: a, to: i }, {
              ...this.options.blockSeparator !== void 0 ? { blockSeparator: this.options.blockSeparator } : {},
              textSerializers: c
            });
          }
        }
      })
    ];
  }
});
const rt = () => ({ editor: e, view: t }) => (requestAnimationFrame(() => {
  var n;
  e.isDestroyed || (t.dom.blur(), (n = window == null ? void 0 : window.getSelection()) === null || n === void 0 || n.removeAllRanges());
}), !0), st = (e = !1) => ({ commands: t }) => t.setContent("", e), it = () => ({ state: e, tr: t, dispatch: n }) => {
  const { selection: o } = t, { ranges: r } = o;
  return n && r.forEach(({ $from: s, $to: a }) => {
    e.doc.nodesBetween(s.pos, a.pos, (i, c) => {
      if (i.type.isText)
        return;
      const { doc: l, mapping: u } = t, d = l.resolve(u.map(c)), f = l.resolve(u.map(c + i.nodeSize)), p = d.blockRange(f);
      if (!p)
        return;
      const m = Ae(p);
      if (i.type.isTextblock) {
        const { defaultType: h } = d.parent.contentMatchAt(d.index());
        t.setNodeMarkup(p.start, h);
      }
      (m || m === 0) && t.lift(p, m);
    });
  }), !0;
}, at = (e) => (t) => e(t), ct = () => ({ state: e, dispatch: t }) => Ee(e, t), lt = (e, t) => ({ editor: n, tr: o }) => {
  const { state: r } = n, s = r.doc.slice(e.from, e.to);
  o.deleteRange(e.from, e.to);
  const a = o.mapping.map(t);
  return o.insert(a, s.content), o.setSelection(new b(o.doc.resolve(a - 1))), !0;
}, dt = () => ({ tr: e, dispatch: t }) => {
  const { selection: n } = e, o = n.$anchor.node();
  if (o.content.size > 0)
    return !1;
  const r = e.selection.$anchor;
  for (let s = r.depth; s > 0; s -= 1)
    if (r.node(s).type === o.type) {
      if (t) {
        const i = r.before(s), c = r.after(s);
        e.delete(i, c).scrollIntoView();
      }
      return !0;
    }
  return !1;
}, ut = (e) => ({ tr: t, state: n, dispatch: o }) => {
  const r = y(e, n.schema), s = t.selection.$anchor;
  for (let a = s.depth; a > 0; a -= 1)
    if (s.node(a).type === r) {
      if (o) {
        const c = s.before(a), l = s.after(a);
        t.delete(c, l).scrollIntoView();
      }
      return !0;
    }
  return !1;
}, ft = (e) => ({ tr: t, dispatch: n }) => {
  const { from: o, to: r } = e;
  return n && t.delete(o, r), !0;
}, pt = () => ({ state: e, dispatch: t }) => Be(e, t), mt = () => ({ commands: e }) => e.keyboardShortcut("Enter"), ht = () => ({ state: e, dispatch: t }) => ve(e, t);
function z(e, t, n = { strict: !0 }) {
  const o = Object.keys(t);
  return o.length ? o.every((r) => n.strict ? t[r] === e[r] : Ze(t[r]) ? t[r].test(e[r]) : t[r] === e[r]) : !0;
}
function q(e, t, n = {}) {
  return e.find((o) => o.type === t && z(o.attrs, n));
}
function gt(e, t, n = {}) {
  return !!q(e, t, n);
}
function pe(e, t, n = {}) {
  if (!e || !t)
    return;
  let o = e.parent.childAfter(e.parentOffset);
  if (e.parentOffset === o.offset && o.offset !== 0 && (o = e.parent.childBefore(e.parentOffset)), !o.node)
    return;
  const r = q([...o.node.marks], t, n);
  if (!r)
    return;
  let s = o.index, a = e.start() + o.offset, i = s + 1, c = a + o.node.nodeSize;
  for (q([...o.node.marks], t, n); s > 0 && r.isInSet(e.parent.child(s - 1).marks); )
    s -= 1, a -= e.parent.child(s).nodeSize;
  for (; i < e.parent.childCount && gt([...e.parent.child(i).marks], t, n); )
    c += e.parent.child(i).nodeSize, i += 1;
  return {
    from: a,
    to: c
  };
}
function I(e, t) {
  if (typeof e == "string") {
    if (!t.marks[e])
      throw Error(`There is no mark type named '${e}'. Maybe you forgot to add the extension?`);
    return t.marks[e];
  }
  return e;
}
const kt = (e, t = {}) => ({ tr: n, state: o, dispatch: r }) => {
  const s = I(e, o.schema), { doc: a, selection: i } = n, { $from: c, from: l, to: u } = i;
  if (r) {
    const d = pe(c, s, t);
    if (d && d.from <= l && d.to >= u) {
      const f = b.create(a, d.from, d.to);
      n.setSelection(f);
    }
  }
  return !0;
}, yt = (e) => (t) => {
  const n = typeof e == "function" ? e(t) : e;
  for (let o = 0; o < n.length; o += 1)
    if (n[o](t))
      return !0;
  return !1;
};
function me(e) {
  return e instanceof b;
}
function P(e = 0, t = 0, n = 0) {
  return Math.min(Math.max(e, t), n);
}
function wt(e, t = null) {
  if (!t)
    return null;
  const n = O.atStart(e), o = O.atEnd(e);
  if (t === "start" || t === !0)
    return n;
  if (t === "end")
    return o;
  const r = n.from, s = o.to;
  return t === "all" ? b.create(e, P(0, r, s), P(e.content.size, r, s)) : b.create(e, P(t, r, s), P(t, r, s));
}
function X() {
  return [
    "iPad Simulator",
    "iPhone Simulator",
    "iPod Simulator",
    "iPad",
    "iPhone",
    "iPod"
  ].includes(navigator.platform) || navigator.userAgent.includes("Mac") && "ontouchend" in document;
}
const xt = (e = null, t = {}) => ({ editor: n, view: o, tr: r, dispatch: s }) => {
  t = {
    scrollIntoView: !0,
    ...t
  };
  const a = () => {
    X() && o.dom.focus(), requestAnimationFrame(() => {
      n.isDestroyed || (o.focus(), t != null && t.scrollIntoView && n.commands.scrollIntoView());
    });
  };
  if (o.hasFocus() && e === null || e === !1)
    return !0;
  if (s && e === null && !me(n.state.selection))
    return a(), !0;
  const i = wt(r.doc, e) || n.state.selection, c = n.state.selection.eq(i);
  return s && (c || r.setSelection(i), c && r.storedMarks && r.setStoredMarks(r.storedMarks), a()), !0;
}, St = (e, t) => (n) => e.every((o, r) => t(o, { ...n, index: r })), bt = (e, t) => ({ tr: n, commands: o }) => o.insertContentAt({ from: n.selection.from, to: n.selection.to }, e, t), he = (e) => {
  const t = e.childNodes;
  for (let n = t.length - 1; n >= 0; n -= 1) {
    const o = t[n];
    o.nodeType === 3 && o.nodeValue && /^(\n\s\s|\n)$/.test(o.nodeValue) ? e.removeChild(o) : o.nodeType === 1 && he(o);
  }
  return e;
};
function te(e) {
  const t = `<body>${e}</body>`, n = new window.DOMParser().parseFromString(t, "text/html").body;
  return he(n);
}
function W(e, t, n) {
  if (n = {
    slice: !0,
    parseOptions: {},
    ...n
  }, typeof e == "object" && e !== null)
    try {
      return Array.isArray(e) && e.length > 0 ? L.fromArray(e.map((o) => t.nodeFromJSON(o))) : t.nodeFromJSON(e);
    } catch (o) {
      return console.warn("[tiptap warn]: Invalid content.", "Passed value:", e, "Error:", o), W("", t, n);
    }
  if (typeof e == "string") {
    const o = Me.fromSchema(t);
    return n.slice ? o.parseSlice(te(e), n.parseOptions).content : o.parse(te(e), n.parseOptions);
  }
  return W("", t, n);
}
function Mt(e, t, n) {
  const o = e.steps.length - 1;
  if (o < t)
    return;
  const r = e.steps[o];
  if (!(r instanceof Te || r instanceof Ce))
    return;
  const s = e.mapping.maps[o];
  let a = 0;
  s.forEach((i, c, l, u) => {
    a === 0 && (a = u);
  }), e.setSelection(O.near(e.doc.resolve(a), n));
}
const At = (e) => e.toString().startsWith("<"), Tt = (e, t, n) => ({ tr: o, dispatch: r, editor: s }) => {
  if (r) {
    n = {
      parseOptions: {},
      updateSelection: !0,
      applyInputRules: !1,
      applyPasteRules: !1,
      ...n
    };
    const a = W(t, s.schema, {
      parseOptions: {
        preserveWhitespace: "full",
        ...n.parseOptions
      }
    });
    if (a.toString() === "<>")
      return !0;
    let { from: i, to: c } = typeof e == "number" ? { from: e, to: e } : { from: e.from, to: e.to }, l = !0, u = !0;
    if ((At(a) ? a : [a]).forEach((p) => {
      p.check(), l = l ? p.isText && p.marks.length === 0 : !1, u = u ? p.isBlock : !1;
    }), i === c && u) {
      const { parent: p } = o.doc.resolve(i);
      p.isTextblock && !p.type.spec.code && !p.childCount && (i -= 1, c += 1);
    }
    let f;
    l ? (Array.isArray(t) ? f = t.map((p) => p.text || "").join("") : typeof t == "object" && t && t.text ? f = t.text : f = t, o.insertText(f, i, c)) : (f = a, o.replaceWith(i, c, f)), n.updateSelection && Mt(o, o.steps.length - 1, -1), n.applyInputRules && o.setMeta("applyInputRules", { from: i, text: f }), n.applyPasteRules && o.setMeta("applyPasteRules", { from: i, text: f });
  }
  return !0;
}, Ct = () => ({ state: e, dispatch: t }) => Ie(e, t), Et = () => ({ state: e, dispatch: t }) => Pe(e, t), Bt = () => ({ state: e, dispatch: t }) => $e(e, t), vt = () => ({ state: e, dispatch: t }) => Ne(e, t), It = () => ({ tr: e, state: t, dispatch: n }) => {
  try {
    const o = ce(t.doc, t.selection.$from.pos, -1);
    return o == null ? !1 : (e.join(o, 2), n && n(e), !0);
  } catch {
    return !1;
  }
}, Pt = () => ({ state: e, dispatch: t, tr: n }) => {
  try {
    const o = ce(e.doc, e.selection.$from.pos, 1);
    return o == null ? !1 : (n.join(o, 2), t && t(n), !0);
  } catch {
    return !1;
  }
}, $t = () => ({ state: e, dispatch: t }) => Oe(e, t), Nt = () => ({ state: e, dispatch: t }) => je(e, t);
function ge() {
  return typeof navigator < "u" ? /Mac/.test(navigator.platform) : !1;
}
function Ot(e) {
  const t = e.split(/-(?!$)/);
  let n = t[t.length - 1];
  n === "Space" && (n = " ");
  let o, r, s, a;
  for (let i = 0; i < t.length - 1; i += 1) {
    const c = t[i];
    if (/^(cmd|meta|m)$/i.test(c))
      a = !0;
    else if (/^a(lt)?$/i.test(c))
      o = !0;
    else if (/^(c|ctrl|control)$/i.test(c))
      r = !0;
    else if (/^s(hift)?$/i.test(c))
      s = !0;
    else if (/^mod$/i.test(c))
      X() || ge() ? a = !0 : r = !0;
    else
      throw new Error(`Unrecognized modifier name: ${c}`);
  }
  return o && (n = `Alt-${n}`), r && (n = `Ctrl-${n}`), a && (n = `Meta-${n}`), s && (n = `Shift-${n}`), n;
}
const jt = (e) => ({ editor: t, view: n, tr: o, dispatch: r }) => {
  const s = Ot(e).split(/-(?!$)/), a = s.find((l) => !["Alt", "Ctrl", "Meta", "Shift"].includes(l)), i = new KeyboardEvent("keydown", {
    key: a === "Space" ? " " : a,
    altKey: s.includes("Alt"),
    ctrlKey: s.includes("Ctrl"),
    metaKey: s.includes("Meta"),
    shiftKey: s.includes("Shift"),
    bubbles: !0,
    cancelable: !0
  }), c = t.captureTransaction(() => {
    n.someProp("handleKeyDown", (l) => l(n, i));
  });
  return c == null || c.steps.forEach((l) => {
    const u = l.map(o.mapping);
    u && r && o.maybeStep(u);
  }), !0;
};
function Y(e, t, n = {}) {
  const { from: o, to: r, empty: s } = e.selection, a = t ? y(t, e.schema) : null, i = [];
  e.doc.nodesBetween(o, r, (d, f) => {
    if (d.isText)
      return;
    const p = Math.max(o, f), m = Math.min(r, f + d.nodeSize);
    i.push({
      node: d,
      from: p,
      to: m
    });
  });
  const c = r - o, l = i.filter((d) => a ? a.name === d.node.type.name : !0).filter((d) => z(d.node.attrs, n, { strict: !1 }));
  return s ? !!l.length : l.reduce((d, f) => d + f.to - f.from, 0) >= c;
}
const Ft = (e, t = {}) => ({ state: n, dispatch: o }) => {
  const r = y(e, n.schema);
  return Y(n, r, t) ? Fe(n, o) : !1;
}, Lt = () => ({ state: e, dispatch: t }) => Le(e, t), Rt = (e) => ({ state: t, dispatch: n }) => {
  const o = y(e, t.schema);
  return _e(o)(t, n);
}, Dt = () => ({ state: e, dispatch: t }) => Re(e, t);
function ke(e, t) {
  return t.nodes[e] ? "node" : t.marks[e] ? "mark" : null;
}
function ne(e, t) {
  const n = typeof t == "string" ? [t] : t;
  return Object.keys(e).reduce((o, r) => (n.includes(r) || (o[r] = e[r]), o), {});
}
const zt = (e, t) => ({ tr: n, state: o, dispatch: r }) => {
  let s = null, a = null;
  const i = ke(typeof e == "string" ? e : e.name, o.schema);
  return i ? (i === "node" && (s = y(e, o.schema)), i === "mark" && (a = I(e, o.schema)), r && n.selection.ranges.forEach((c) => {
    o.doc.nodesBetween(c.$from.pos, c.$to.pos, (l, u) => {
      s && s === l.type && n.setNodeMarkup(u, void 0, ne(l.attrs, t)), a && l.marks.length && l.marks.forEach((d) => {
        a === d.type && n.addMark(u, u + l.nodeSize, a.create(ne(d.attrs, t)));
      });
    });
  }), !0) : !1;
}, Wt = () => ({ tr: e, dispatch: t }) => (t && e.scrollIntoView(), !0), Ht = () => ({ tr: e, commands: t }) => t.setTextSelection({
  from: 0,
  to: e.doc.content.size
}), Kt = () => ({ state: e, dispatch: t }) => De(e, t), Vt = () => ({ state: e, dispatch: t }) => ze(e, t), _t = () => ({ state: e, dispatch: t }) => We(e, t), Jt = () => ({ state: e, dispatch: t }) => He(e, t), Ut = () => ({ state: e, dispatch: t }) => Ke(e, t);
function Gt(e, t, n = {}) {
  return W(e, t, { slice: !1, parseOptions: n });
}
const qt = (e, t = !1, n = {}) => ({ tr: o, editor: r, dispatch: s }) => {
  const { doc: a } = o, i = Gt(e, r.schema, n);
  return s && o.replaceWith(0, a.content.size, i).setMeta("preventUpdate", !t), !0;
};
function Qt(e, t) {
  const n = I(t, e.schema), { from: o, to: r, empty: s } = e.selection, a = [];
  s ? (e.storedMarks && a.push(...e.storedMarks), a.push(...e.selection.$head.marks())) : e.doc.nodesBetween(o, r, (c) => {
    a.push(...c.marks);
  });
  const i = a.find((c) => c.type.name === n.name);
  return i ? { ...i.attrs } : {};
}
function Xt(e) {
  for (let t = 0; t < e.edgeCount; t += 1) {
    const { type: n } = e.edge(t);
    if (n.isTextblock && !n.hasRequiredAttrs())
      return n;
  }
  return null;
}
function F(e, t) {
  const n = [];
  return e.descendants((o, r) => {
    t(o) && n.push({
      node: o,
      pos: r
    });
  }), n;
}
function Yt(e, t) {
  for (let n = e.depth; n > 0; n -= 1) {
    const o = e.node(n);
    if (t(o))
      return {
        pos: n > 0 ? e.before(n) : 0,
        start: e.start(n),
        depth: n,
        node: o
      };
  }
}
function Z(e) {
  return (t) => Yt(t.$from, e);
}
function D(e, t, n) {
  return Object.fromEntries(Object.entries(n).filter(([o]) => {
    const r = e.find((s) => s.type === t && s.name === o);
    return r ? r.attribute.keepOnSplit : !1;
  }));
}
function Zt(e, t, n = {}) {
  const { empty: o, ranges: r } = e.selection, s = t ? I(t, e.schema) : null;
  if (o)
    return !!(e.storedMarks || e.selection.$from.marks()).filter((d) => s ? s.name === d.type.name : !0).find((d) => z(d.attrs, n, { strict: !1 }));
  let a = 0;
  const i = [];
  if (r.forEach(({ $from: d, $to: f }) => {
    const p = d.pos, m = f.pos;
    e.doc.nodesBetween(p, m, (h, g) => {
      if (!h.isText && !h.marks.length)
        return;
      const k = Math.max(p, g), E = Math.min(m, g + h.nodeSize), M = E - k;
      a += M, i.push(...h.marks.map((B) => ({
        mark: B,
        from: k,
        to: E
      })));
    });
  }), a === 0)
    return !1;
  const c = i.filter((d) => s ? s.name === d.mark.type.name : !0).filter((d) => z(d.mark.attrs, n, { strict: !1 })).reduce((d, f) => d + f.to - f.from, 0), l = i.filter((d) => s ? d.mark.type !== s && d.mark.type.excludes(s) : !0).reduce((d, f) => d + f.to - f.from, 0);
  return (c > 0 ? c + l : c) >= a;
}
function oe(e, t) {
  const { nodeExtensions: n } = Qe(t), o = n.find((a) => a.name === e);
  if (!o)
    return !1;
  const r = {
    name: o.name,
    options: o.options,
    storage: o.storage
  }, s = x(w(o, "group", r));
  return typeof s != "string" ? !1 : s.split(" ").includes("list");
}
function en(e, t, n) {
  var o;
  const { selection: r } = t;
  let s = null;
  if (me(r) && (s = r.$cursor), s) {
    const i = (o = e.storedMarks) !== null && o !== void 0 ? o : s.marks();
    return !!n.isInSet(i) || !i.some((c) => c.type.excludes(n));
  }
  const { ranges: a } = r;
  return a.some(({ $from: i, $to: c }) => {
    let l = i.depth === 0 ? e.doc.inlineContent && e.doc.type.allowsMarkType(n) : !1;
    return e.doc.nodesBetween(i.pos, c.pos, (u, d, f) => {
      if (l)
        return !1;
      if (u.isInline) {
        const p = !f || f.type.allowsMarkType(n), m = !!n.isInSet(u.marks) || !u.marks.some((h) => h.type.excludes(n));
        l = p && m;
      }
      return !l;
    }), l;
  });
}
const tn = (e, t = {}) => ({ tr: n, state: o, dispatch: r }) => {
  const { selection: s } = n, { empty: a, ranges: i } = s, c = I(e, o.schema);
  if (r)
    if (a) {
      const l = Qt(o, c);
      n.addStoredMark(c.create({
        ...l,
        ...t
      }));
    } else
      i.forEach((l) => {
        const u = l.$from.pos, d = l.$to.pos;
        o.doc.nodesBetween(u, d, (f, p) => {
          const m = Math.max(p, u), h = Math.min(p + f.nodeSize, d);
          f.marks.find((k) => k.type === c) ? f.marks.forEach((k) => {
            c === k.type && n.addMark(m, h, c.create({
              ...k.attrs,
              ...t
            }));
          }) : n.addMark(m, h, c.create(t));
        });
      });
  return en(o, n, c);
}, nn = (e, t) => ({ tr: n }) => (n.setMeta(e, t), !0), on = (e, t = {}) => ({ state: n, dispatch: o, chain: r }) => {
  const s = y(e, n.schema);
  return s.isTextblock ? r().command(({ commands: a }) => ee(s, t)(n) ? !0 : a.clearNodes()).command(({ state: a }) => ee(s, t)(a, o)).run() : (console.warn('[tiptap warn]: Currently "setNode()" only supports text block nodes.'), !1);
}, rn = (e) => ({ tr: t, dispatch: n }) => {
  if (n) {
    const { doc: o } = t, r = P(e, 0, o.content.size), s = ae.create(o, r);
    t.setSelection(s);
  }
  return !0;
}, sn = (e) => ({ tr: t, dispatch: n }) => {
  if (n) {
    const { doc: o } = t, { from: r, to: s } = typeof e == "number" ? { from: e, to: e } : e, a = b.atStart(o).from, i = b.atEnd(o).to, c = P(r, a, i), l = P(s, a, i), u = b.create(o, c, l);
    t.setSelection(u);
  }
  return !0;
}, an = (e) => ({ state: t, dispatch: n }) => {
  const o = y(e, t.schema);
  return Je(o)(t, n);
};
function re(e, t) {
  const n = e.storedMarks || e.selection.$to.parentOffset && e.selection.$from.marks();
  if (n) {
    const o = n.filter((r) => t == null ? void 0 : t.includes(r.type.name));
    e.tr.ensureMarks(o);
  }
}
const cn = ({ keepMarks: e = !0 } = {}) => ({ tr: t, state: n, dispatch: o, editor: r }) => {
  const { selection: s, doc: a } = t, { $from: i, $to: c } = s, l = r.extensionManager.attributes, u = D(l, i.node().type.name, i.node().attrs);
  if (s instanceof ae && s.node.isBlock)
    return !i.parentOffset || !R(a, i.pos) ? !1 : (o && (e && re(n, r.extensionManager.splittableMarks), t.split(i.pos).scrollIntoView()), !0);
  if (!i.parent.isBlock)
    return !1;
  if (o) {
    const d = c.parentOffset === c.parent.content.size;
    s instanceof b && t.deleteSelection();
    const f = i.depth === 0 ? void 0 : Xt(i.node(-1).contentMatchAt(i.indexAfter(-1)));
    let p = d && f ? [
      {
        type: f,
        attrs: u
      }
    ] : void 0, m = R(t.doc, t.mapping.map(i.pos), 1, p);
    if (!p && !m && R(t.doc, t.mapping.map(i.pos), 1, f ? [{ type: f }] : void 0) && (m = !0, p = f ? [
      {
        type: f,
        attrs: u
      }
    ] : void 0), m && (t.split(t.mapping.map(i.pos), 1, p), f && !d && !i.parentOffset && i.parent.type !== f)) {
      const h = t.mapping.map(i.before()), g = t.doc.resolve(h);
      i.node(-1).canReplaceWith(g.index(), g.index() + 1, f) && t.setNodeMarkup(t.mapping.map(i.before()), f);
    }
    e && re(n, r.extensionManager.splittableMarks), t.scrollIntoView();
  }
  return !0;
}, ln = (e) => ({ tr: t, state: n, dispatch: o, editor: r }) => {
  var s;
  const a = y(e, n.schema), { $from: i, $to: c } = n.selection, l = n.selection.node;
  if (l && l.isBlock || i.depth < 2 || !i.sameParent(c))
    return !1;
  const u = i.node(-1);
  if (u.type !== a)
    return !1;
  const d = r.extensionManager.attributes;
  if (i.parent.content.size === 0 && i.node(-1).childCount === i.indexAfter(-1)) {
    if (i.depth === 2 || i.node(-3).type !== a || i.index(-2) !== i.node(-2).childCount - 1)
      return !1;
    if (o) {
      let g = L.empty;
      const k = i.index(-1) ? 1 : i.index(-2) ? 2 : 3;
      for (let v = i.depth - k; v >= i.depth - 3; v -= 1)
        g = L.from(i.node(v).copy(g));
      const E = i.indexAfter(-1) < i.node(-2).childCount ? 1 : i.indexAfter(-2) < i.node(-3).childCount ? 2 : 3, M = D(d, i.node().type.name, i.node().attrs), B = ((s = a.contentMatch.defaultType) === null || s === void 0 ? void 0 : s.createAndFill(M)) || void 0;
      g = g.append(L.from(a.createAndFill(null, B) || void 0));
      const S = i.before(i.depth - (k - 1));
      t.replace(S, i.after(-E), new be(g, 4 - k, 0));
      let T = -1;
      t.doc.nodesBetween(S, t.doc.content.size, (v, K) => {
        if (T > -1)
          return !1;
        v.isTextblock && v.content.size === 0 && (T = K + 1);
      }), T > -1 && t.setSelection(b.near(t.doc.resolve(T))), t.scrollIntoView();
    }
    return !0;
  }
  const f = c.pos === i.end() ? u.contentMatchAt(0).defaultType : null, p = D(d, u.type.name, u.attrs), m = D(d, i.node().type.name, i.node().attrs);
  t.delete(i.pos, c.pos);
  const h = f ? [
    { type: a, attrs: p },
    { type: f, attrs: m }
  ] : [{ type: a, attrs: p }];
  if (!R(t.doc, i.pos, 2))
    return !1;
  if (o) {
    const { selection: g, storedMarks: k } = n, { splittableMarks: E } = r.extensionManager, M = k || g.$to.parentOffset && g.$from.marks();
    if (t.split(i.pos, 2, h).scrollIntoView(), !M || !o)
      return !0;
    const B = M.filter((S) => E.includes(S.type.name));
    t.ensureMarks(B);
  }
  return !0;
}, _ = (e, t) => {
  const n = Z((a) => a.type === t)(e.selection);
  if (!n)
    return !0;
  const o = e.doc.resolve(Math.max(0, n.pos - 1)).before(n.depth);
  if (o === void 0)
    return !0;
  const r = e.doc.nodeAt(o);
  return n.node.type === (r == null ? void 0 : r.type) && le(e.doc, n.pos) && e.join(n.pos), !0;
}, J = (e, t) => {
  const n = Z((a) => a.type === t)(e.selection);
  if (!n)
    return !0;
  const o = e.doc.resolve(n.start).after(n.depth);
  if (o === void 0)
    return !0;
  const r = e.doc.nodeAt(o);
  return n.node.type === (r == null ? void 0 : r.type) && le(e.doc, o) && e.join(o), !0;
}, dn = (e, t, n, o = {}) => ({ editor: r, tr: s, state: a, dispatch: i, chain: c, commands: l, can: u }) => {
  const { extensions: d, splittableMarks: f } = r.extensionManager, p = y(e, a.schema), m = y(t, a.schema), { selection: h, storedMarks: g } = a, { $from: k, $to: E } = h, M = k.blockRange(E), B = g || h.$to.parentOffset && h.$from.marks();
  if (!M)
    return !1;
  const S = Z((T) => oe(T.type.name, d))(h);
  if (M.depth >= 1 && S && M.depth - S.depth <= 1) {
    if (S.node.type === p)
      return l.liftListItem(m);
    if (oe(S.node.type.name, d) && p.validContent(S.node.content) && i)
      return c().command(() => (s.setNodeMarkup(S.pos, p), !0)).command(() => _(s, p)).command(() => J(s, p)).run();
  }
  return !n || !B || !i ? c().command(() => u().wrapInList(p, o) ? !0 : l.clearNodes()).wrapInList(p, o).command(() => _(s, p)).command(() => J(s, p)).run() : c().command(() => {
    const T = u().wrapInList(p, o), v = B.filter((K) => f.includes(K.type.name));
    return s.ensureMarks(v), T ? !0 : l.clearNodes();
  }).wrapInList(p, o).command(() => _(s, p)).command(() => J(s, p)).run();
}, un = (e, t = {}, n = {}) => ({ state: o, commands: r }) => {
  const { extendEmptyMarkRange: s = !1 } = n, a = I(e, o.schema);
  return Zt(o, a, t) ? r.unsetMark(a, { extendEmptyMarkRange: s }) : r.setMark(a, t);
}, fn = (e, t, n = {}) => ({ state: o, commands: r }) => {
  const s = y(e, o.schema), a = y(t, o.schema);
  return Y(o, s, n) ? r.setNode(a) : r.setNode(s, n);
}, pn = (e, t = {}) => ({ state: n, commands: o }) => {
  const r = y(e, n.schema);
  return Y(n, r, t) ? o.lift(r) : o.wrapIn(r, t);
}, mn = () => ({ state: e, dispatch: t }) => {
  const n = e.plugins;
  for (let o = 0; o < n.length; o += 1) {
    const r = n[o];
    let s;
    if (r.spec.isInputRules && (s = r.getState(e))) {
      if (t) {
        const a = e.tr, i = s.transform;
        for (let c = i.steps.length - 1; c >= 0; c -= 1)
          a.step(i.steps[c].invert(i.docs[c]));
        if (s.text) {
          const c = a.doc.resolve(s.from).marks();
          a.replaceWith(s.from, s.to, e.schema.text(s.text, c));
        } else
          a.delete(s.from, s.to);
      }
      return !0;
    }
  }
  return !1;
}, hn = () => ({ tr: e, dispatch: t }) => {
  const { selection: n } = e, { empty: o, ranges: r } = n;
  return o || t && r.forEach((s) => {
    e.removeMark(s.$from.pos, s.$to.pos);
  }), !0;
}, gn = (e, t = {}) => ({ tr: n, state: o, dispatch: r }) => {
  var s;
  const { extendEmptyMarkRange: a = !1 } = t, { selection: i } = n, c = I(e, o.schema), { $from: l, empty: u, ranges: d } = i;
  if (!r)
    return !0;
  if (u && a) {
    let { from: f, to: p } = i;
    const m = (s = l.marks().find((g) => g.type === c)) === null || s === void 0 ? void 0 : s.attrs, h = pe(l, c, m);
    h && (f = h.from, p = h.to), n.removeMark(f, p, c);
  } else
    d.forEach((f) => {
      n.removeMark(f.$from.pos, f.$to.pos, c);
    });
  return n.removeStoredMark(c), !0;
}, kn = (e, t = {}) => ({ tr: n, state: o, dispatch: r }) => {
  let s = null, a = null;
  const i = ke(typeof e == "string" ? e : e.name, o.schema);
  return i ? (i === "node" && (s = y(e, o.schema)), i === "mark" && (a = I(e, o.schema)), r && n.selection.ranges.forEach((c) => {
    const l = c.$from.pos, u = c.$to.pos;
    o.doc.nodesBetween(l, u, (d, f) => {
      s && s === d.type && n.setNodeMarkup(f, void 0, {
        ...d.attrs,
        ...t
      }), a && d.marks.length && d.marks.forEach((p) => {
        if (a === p.type) {
          const m = Math.max(f, l), h = Math.min(f + d.nodeSize, u);
          n.addMark(m, h, a.create({
            ...p.attrs,
            ...t
          }));
        }
      });
    });
  }), !0) : !1;
}, yn = (e, t = {}) => ({ state: n, dispatch: o }) => {
  const r = y(e, n.schema);
  return Ve(r, t)(n, o);
}, wn = (e, t = {}) => ({ state: n, dispatch: o }) => {
  const r = y(e, n.schema);
  return Ue(r, t)(n, o);
};
var xn = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  blur: rt,
  clearContent: st,
  clearNodes: it,
  command: at,
  createParagraphNear: ct,
  cut: lt,
  deleteCurrentNode: dt,
  deleteNode: ut,
  deleteRange: ft,
  deleteSelection: pt,
  enter: mt,
  exitCode: ht,
  extendMarkRange: kt,
  first: yt,
  focus: xt,
  forEach: St,
  insertContent: bt,
  insertContentAt: Tt,
  joinUp: Ct,
  joinDown: Et,
  joinBackward: Bt,
  joinForward: vt,
  joinItemBackward: It,
  joinItemForward: Pt,
  joinTextblockBackward: $t,
  joinTextblockForward: Nt,
  keyboardShortcut: jt,
  lift: Ft,
  liftEmptyBlock: Lt,
  liftListItem: Rt,
  newlineInCode: Dt,
  resetAttributes: zt,
  scrollIntoView: Wt,
  selectAll: Ht,
  selectNodeBackward: Kt,
  selectNodeForward: Vt,
  selectParentNode: _t,
  selectTextblockEnd: Jt,
  selectTextblockStart: Ut,
  setContent: qt,
  setMark: tn,
  setMeta: nn,
  setNode: on,
  setNodeSelection: rn,
  setTextSelection: sn,
  sinkListItem: an,
  splitBlock: cn,
  splitListItem: ln,
  toggleList: dn,
  toggleMark: un,
  toggleNode: fn,
  toggleWrap: pn,
  undoInputRule: mn,
  unsetAllMarks: hn,
  unsetMark: gn,
  updateAttributes: kn,
  wrapIn: yn,
  wrapInList: wn
});
C.create({
  name: "commands",
  addCommands() {
    return {
      ...xn
    };
  }
});
C.create({
  name: "editable",
  addProseMirrorPlugins() {
    return [
      new $({
        key: new N("editable"),
        props: {
          editable: () => this.editor.options.editable
        }
      })
    ];
  }
});
C.create({
  name: "focusEvents",
  addProseMirrorPlugins() {
    const { editor: e } = this;
    return [
      new $({
        key: new N("focusEvents"),
        props: {
          handleDOMEvents: {
            focus: (t, n) => {
              e.isFocused = !0;
              const o = e.state.tr.setMeta("focus", { event: n }).setMeta("addToHistory", !1);
              return t.dispatch(o), !1;
            },
            blur: (t, n) => {
              e.isFocused = !1;
              const o = e.state.tr.setMeta("blur", { event: n }).setMeta("addToHistory", !1);
              return t.dispatch(o), !1;
            }
          }
        }
      })
    ];
  }
});
C.create({
  name: "keymap",
  addKeyboardShortcuts() {
    const e = () => this.editor.commands.first(({ commands: a }) => [
      () => a.undoInputRule(),
      // maybe convert first text block node to default node
      () => a.command(({ tr: i }) => {
        const { selection: c, doc: l } = i, { empty: u, $anchor: d } = c, { pos: f, parent: p } = d, m = d.parent.isTextblock && f > 0 ? i.doc.resolve(f - 1) : d, h = m.parent.type.spec.isolating, g = d.pos - d.parentOffset, k = h && m.parent.childCount === 1 ? g === d.pos : O.atStart(l).from === f;
        return !u || !k || !p.type.isTextblock || p.textContent.length ? !1 : a.clearNodes();
      }),
      () => a.deleteSelection(),
      () => a.joinBackward(),
      () => a.selectNodeBackward()
    ]), t = () => this.editor.commands.first(({ commands: a }) => [
      () => a.deleteSelection(),
      () => a.deleteCurrentNode(),
      () => a.joinForward(),
      () => a.selectNodeForward()
    ]), o = {
      Enter: () => this.editor.commands.first(({ commands: a }) => [
        () => a.newlineInCode(),
        () => a.createParagraphNear(),
        () => a.liftEmptyBlock(),
        () => a.splitBlock()
      ]),
      "Mod-Enter": () => this.editor.commands.exitCode(),
      Backspace: e,
      "Mod-Backspace": e,
      "Shift-Backspace": e,
      Delete: t,
      "Mod-Delete": t,
      "Mod-a": () => this.editor.commands.selectAll()
    }, r = {
      ...o
    }, s = {
      ...o,
      "Ctrl-h": e,
      "Alt-Backspace": e,
      "Ctrl-d": t,
      "Ctrl-Alt-Backspace": t,
      "Alt-Delete": t,
      "Alt-d": t,
      "Ctrl-a": () => this.editor.commands.selectTextblockStart(),
      "Ctrl-e": () => this.editor.commands.selectTextblockEnd()
    };
    return X() || ge() ? s : r;
  },
  addProseMirrorPlugins() {
    return [
      // With this plugin we check if the whole document was selected and deleted.
      // In this case we will additionally call `clearNodes()` to convert e.g. a heading
      // to a paragraph if necessary.
      // This is an alternative to ProseMirror's `AllSelection`, which doesn’t work well
      // with many other commands.
      new $({
        key: new N("clearDocument"),
        appendTransaction: (e, t, n) => {
          if (!(e.some((m) => m.docChanged) && !t.doc.eq(n.doc)))
            return;
          const { empty: r, from: s, to: a } = t.selection, i = O.atStart(t.doc).from, c = O.atEnd(t.doc).to;
          if (r || !(s === i && a === c) || !(n.doc.textBetween(0, n.doc.content.size, " ", " ").length === 0))
            return;
          const d = n.tr, f = fe({
            state: n,
            transaction: d
          }), { commands: p } = new qe({
            editor: this.editor,
            state: f
          });
          if (p.clearNodes(), !!d.steps.length)
            return d;
        }
      })
    ];
  }
});
C.create({
  name: "tabindex",
  addProseMirrorPlugins() {
    return [
      new $({
        key: new N("tabindex"),
        props: {
          attributes: this.editor.isEditable ? { tabindex: "0" } : {}
        }
      })
    ];
  }
});
function se(e) {
  return new et({
    find: e.find,
    handler: ({ state: t, range: n, match: o }) => {
      const r = t.doc.resolve(n.from), s = x(e.getAttributes, void 0, o) || {};
      if (!r.node(-1).canReplaceWith(r.index(-1), r.indexAfter(-1), e.type))
        return null;
      t.tr.delete(n.from, n.to).setBlockType(n.from, n.from, e.type, s);
    }
  });
}
class H {
  constructor(t = {}) {
    this.type = "node", this.name = "node", this.parent = null, this.child = null, this.config = {
      name: this.name,
      defaultOptions: {}
    }, this.config = {
      ...this.config,
      ...t
    }, this.name = this.config.name, t.defaultOptions && Object.keys(t.defaultOptions).length > 0 && console.warn(`[tiptap warn]: BREAKING CHANGE: "defaultOptions" is deprecated. Please use "addOptions" instead. Found in extension: "${this.name}".`), this.options = this.config.defaultOptions, this.config.addOptions && (this.options = x(w(this, "addOptions", {
      name: this.name
    }))), this.storage = x(w(this, "addStorage", {
      name: this.name,
      options: this.options
    })) || {};
  }
  static create(t = {}) {
    return new H(t);
  }
  configure(t = {}) {
    const n = this.extend();
    return n.options = Q(this.options, t), n.storage = x(w(n, "addStorage", {
      name: n.name,
      options: n.options
    })), n;
  }
  extend(t = {}) {
    const n = new H({ ...this.config, ...t });
    return n.parent = this, this.child = n, n.name = t.name ? t.name : n.parent.name, t.defaultOptions && console.warn(`[tiptap warn]: BREAKING CHANGE: "defaultOptions" is deprecated. Please use "addOptions" instead. Found in extension: "${n.name}".`), n.options = x(w(n, "addOptions", {
      name: n.name
    })), n.storage = x(w(n, "addStorage", {
      name: n.name,
      options: n.options
    })), n;
  }
}
const Sn = /^```([a-z]+)?[\s\n]$/, bn = /^~~~([a-z]+)?[\s\n]$/, Mn = H.create({
  name: "codeBlock",
  addOptions() {
    return {
      languageClassPrefix: "language-",
      exitOnTripleEnter: !0,
      exitOnArrowDown: !0,
      HTMLAttributes: {}
    };
  },
  content: "text*",
  marks: "",
  group: "block",
  code: !0,
  defining: !0,
  addAttributes() {
    return {
      language: {
        default: null,
        parseHTML: (e) => {
          var t;
          const { languageClassPrefix: n } = this.options, s = [...((t = e.firstElementChild) === null || t === void 0 ? void 0 : t.classList) || []].filter((a) => a.startsWith(n)).map((a) => a.replace(n, ""))[0];
          return s || null;
        },
        rendered: !1
      }
    };
  },
  parseHTML() {
    return [
      {
        tag: "pre",
        preserveWhitespace: "full"
      }
    ];
  },
  renderHTML({ node: e, HTMLAttributes: t }) {
    return [
      "pre",
      Xe(this.options.HTMLAttributes, t),
      [
        "code",
        {
          class: e.attrs.language ? this.options.languageClassPrefix + e.attrs.language : null
        },
        0
      ]
    ];
  },
  addCommands() {
    return {
      setCodeBlock: (e) => ({ commands: t }) => t.setNode(this.name, e),
      toggleCodeBlock: (e) => ({ commands: t }) => t.toggleNode(this.name, "paragraph", e)
    };
  },
  addKeyboardShortcuts() {
    return {
      "Mod-Alt-c": () => this.editor.commands.toggleCodeBlock(),
      // remove code block when at start of document or code block is empty
      Backspace: () => {
        const { empty: e, $anchor: t } = this.editor.state.selection, n = t.pos === 1;
        return !e || t.parent.type.name !== this.name ? !1 : n || !t.parent.textContent.length ? this.editor.commands.clearNodes() : !1;
      },
      // exit node on triple enter
      Enter: ({ editor: e }) => {
        if (!this.options.exitOnTripleEnter)
          return !1;
        const { state: t } = e, { selection: n } = t, { $from: o, empty: r } = n;
        if (!r || o.parent.type !== this.type)
          return !1;
        const s = o.parentOffset === o.parent.nodeSize - 2, a = o.parent.textContent.endsWith(`

`);
        return !s || !a ? !1 : e.chain().command(({ tr: i }) => (i.delete(o.pos - 2, o.pos), !0)).exitCode().run();
      },
      // exit node on arrow down
      ArrowDown: ({ editor: e }) => {
        if (!this.options.exitOnArrowDown)
          return !1;
        const { state: t } = e, { selection: n, doc: o } = t, { $from: r, empty: s } = n;
        if (!s || r.parent.type !== this.type || !(r.parentOffset === r.parent.nodeSize - 2))
          return !1;
        const i = r.after();
        return i === void 0 || o.nodeAt(i) ? !1 : e.commands.exitCode();
      }
    };
  },
  addInputRules() {
    return [
      se({
        find: Sn,
        type: this.type,
        getAttributes: (e) => ({
          language: e[1]
        })
      }),
      se({
        find: bn,
        type: this.type,
        getAttributes: (e) => ({
          language: e[1]
        })
      })
    ];
  },
  addProseMirrorPlugins() {
    return [
      // this plugin creates a code block for pasted content from VS Code
      // we can also detect the copied code language
      new $({
        key: new N("codeBlockVSCodeHandler"),
        props: {
          handlePaste: (e, t) => {
            if (!t.clipboardData || this.editor.isActive(this.type.name))
              return !1;
            const n = t.clipboardData.getData("text/plain"), o = t.clipboardData.getData("vscode-editor-data"), r = o ? JSON.parse(o) : void 0, s = r == null ? void 0 : r.mode;
            if (!n || !s)
              return !1;
            const { tr: a } = e.state;
            return a.replaceSelectionWith(this.type.create({ language: s })), a.setSelection(b.near(a.doc.resolve(Math.max(0, a.selection.from - 2)))), a.insertText(n.replace(/\r\n?/g, `
`)), a.setMeta("paste", !0), e.dispatch(a), !0;
          }
        }
      })
    ];
  }
});
let A, j;
const U = /* @__PURE__ */ new Set(), G = /* @__PURE__ */ new Set();
function An() {
  return A;
}
function Tn(e) {
  if (!A && !j) {
    const t = e.themes.filter(
      (o) => !!o && o in de
    ), n = e.languages.filter(
      (o) => !!o && o in ue
    );
    return j = Ge({ themes: t, langs: n }).then((o) => {
      A = o;
    }), j;
  }
  if (j)
    return j;
}
async function ye(e) {
  return A && !A.getLoadedThemes().includes(e) && !G.has(e) && e in de ? (G.add(e), await A.loadTheme(e), G.delete(e), !0) : !1;
}
async function we(e) {
  return A && !A.getLoadedLanguages().includes(e) && !U.has(e) && e in ue ? (U.add(e), await A.loadLanguage(e), U.delete(e), !0) : !1;
}
async function Cn({
  doc: e,
  name: t,
  defaultTheme: n,
  defaultLanguage: o
}) {
  const r = F(e, (i) => i.type.name === t), s = [
    ...r.map((i) => i.node.attrs.theme),
    n
  ], a = [
    ...r.map((i) => i.node.attrs.language),
    o
  ];
  A ? await Promise.all([
    ...s.flatMap((i) => ye(i)),
    ...a.flatMap((i) => !!i && we(i))
  ]) : await Tn({ languages: a, themes: s });
}
function ie({
  doc: e,
  name: t,
  defaultTheme: n,
  defaultLanguage: o
}) {
  const r = [];
  return F(e, (a) => a.type.name === t).forEach((a) => {
    let i = a.pos + 1, c = a.node.attrs.language || o, l = a.node.attrs.theme || n;
    const u = An();
    if (!u)
      return;
    u.getLoadedLanguages().includes(c) || (c = "plaintext");
    const d = u.getLoadedThemes().includes(l) ? l : u.getLoadedThemes()[0], f = u.codeToTokensBase(a.node.textContent, {
      lang: c,
      theme: d
    });
    for (const p of f) {
      for (const m of p) {
        const h = i + m.content.length, g = Se.inline(i, h, {
          style: `color: ${m.color}`
        });
        r.push(g), i = h;
      }
      i += 1;
    }
  }), xe.create(e, r);
}
function En({
  name: e,
  defaultLanguage: t,
  defaultTheme: n
}) {
  const o = new $({
    key: new N("shiki"),
    view(r) {
      class s {
        constructor() {
          this.initDecorations();
        }
        update() {
          this.checkUndecoratedBlocks();
        }
        destroy() {
        }
        // Initialize shiki async, and then highlight initial document
        async initDecorations() {
          const i = r.state.doc;
          await Cn({ doc: i, name: e, defaultLanguage: t, defaultTheme: n });
          const c = r.state.tr.setMeta("shikiPluginForceDecoration", !0);
          r.dispatch(c);
        }
        // When new codeblocks were added and they have missing themes or
        // languages, load those and then add code decorations once again.
        async checkUndecoratedBlocks() {
          const i = F(
            r.state.doc,
            (u) => u.type.name === e
          );
          if ((await Promise.all(
            i.flatMap((u) => [
              ye(u.node.attrs.theme),
              we(u.node.attrs.language)
            ])
          )).includes(!0)) {
            const u = r.state.tr.setMeta("shikiPluginForceDecoration", !0);
            r.dispatch(u);
          }
        }
      }
      return new s();
    },
    state: {
      init: (r, { doc: s }) => ie({
        doc: s,
        name: e,
        defaultLanguage: t,
        defaultTheme: n
      }),
      apply: (r, s, a, i) => {
        const c = a.selection.$head.parent.type.name, l = i.selection.$head.parent.type.name, u = F(
          a.doc,
          (p) => p.type.name === e
        ), d = F(
          i.doc,
          (p) => p.type.name === e
        ), f = r.docChanged && // Apply decorations if:
        // selection includes named node,
        ([c, l].includes(e) || // OR transaction adds/removes named node,
        d.length !== u.length || // OR transaction has changes that completely encapsulte a node
        // (for example, a transaction that affects the entire document).
        // Such transactions can happen during collab syncing via y-prosemirror, for example.
        r.steps.some((p) => (
          // @ts-ignore
          p.from !== void 0 && // @ts-ignore
          p.to !== void 0 && u.some((m) => (
            // @ts-ignore
            m.pos >= p.from && // @ts-ignore
            m.pos + m.node.nodeSize <= p.to
          ))
        )));
        return r.getMeta("shikiPluginForceDecoration") || f ? ie({
          doc: r.doc,
          name: e,
          defaultLanguage: t,
          defaultTheme: n
        }) : s.map(r.mapping, r.doc);
      }
    },
    props: {
      decorations(r) {
        return o.getState(r);
      }
    }
  });
  return o;
}
const Fn = Mn.extend({
  addOptions() {
    var e;
    return {
      ...(e = this.parent) == null ? void 0 : e.call(this),
      defaultLanguage: null,
      defaultTheme: "github-dark"
    };
  },
  addProseMirrorPlugins() {
    var e;
    return [
      ...((e = this.parent) == null ? void 0 : e.call(this)) || [],
      En({
        name: this.name,
        defaultLanguage: this.options.defaultLanguage,
        defaultTheme: this.options.defaultTheme
      })
    ];
  }
});
export {
  Fn as CodeBlockShiki,
  Fn as default
};
